aboutsummaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
authorDavid E. O'Brien <obrien@FreeBSD.org>2012-06-06 00:20:13 +0000
committerDavid E. O'Brien <obrien@FreeBSD.org>2012-06-06 00:20:13 +0000
commit674607983b00cd7ea83a2bc02b44b5a1043cfef5 (patch)
treee9ae78362034ee438880c409d2fdc400fa800459 /tools
parent9ad569771a09a83a522168b17b1f40590da4a38e (diff)
parent432a06aa0100136d1c8d04df1da990f7ecf6775b (diff)
downloadsrc-674607983b00cd7ea83a2bc02b44b5a1043cfef5.tar.gz
src-674607983b00cd7ea83a2bc02b44b5a1043cfef5.zip
MFC: r236422, r236592, r236593, r236594, r236620, r236621, r236622, & r236637
filemon(4)
Notes
Notes: svn path=/projects/bmake/; revision=236647
Diffstat (limited to 'tools')
-rw-r--r--tools/regression/filemon/Makefile26
-rw-r--r--tools/regression/filemon/filemontest.c80
-rwxr-xr-xtools/regression/filemon/test_script.sh43
3 files changed, 149 insertions, 0 deletions
diff --git a/tools/regression/filemon/Makefile b/tools/regression/filemon/Makefile
new file mode 100644
index 000000000000..dcad932b01a8
--- /dev/null
+++ b/tools/regression/filemon/Makefile
@@ -0,0 +1,26 @@
+# $FreeBSD$
+
+PROG= filemontest
+
+NO_MAN=
+
+WARNS?= 6
+CFLAGS+= -I${.CURDIR}/../../../sys
+
+# Cannot use .OBJDIR -- 'filemontest' expects 'test_script.sh' in .
+test: ${PROG} clean-test
+ cd ${.CURDIR} ; \
+ for A in 1 2 3 4 5 6 7 8 9 0; do \
+ for B in 1 2 3 4 5 6 7 8 9 0; do \
+ for C in 1 2 3 4 5 6 7 8 9 0; do \
+ ${.OBJDIR}/${PROG} ;\
+ done ;\
+ done ;\
+ done
+ @cd ${.CURDIR} ; set +e ; egrep '(Start|Stop) .*\.' filemon_log.* | \
+ grep -q -v '\.[0-9][0-9][0-9][0-9][0-9][0-9]$$' || echo "Time stamp format OK"
+
+clean-test:
+ cd ${.CURDIR} ; rm -f filemon_log.*
+
+.include <bsd.prog.mk>
diff --git a/tools/regression/filemon/filemontest.c b/tools/regression/filemon/filemontest.c
new file mode 100644
index 000000000000..6f0254746b55
--- /dev/null
+++ b/tools/regression/filemon/filemontest.c
@@ -0,0 +1,80 @@
+/*-
+ * Copyright (c) 2009-2011, Juniper Networks, Inc.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ * notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ * notice, this list of conditions and the following disclaimer in the
+ * documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY JUNIPER NETWORKS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL JUNIPER NETWORKS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/types.h>
+__FBSDID("$FreeBSD$");
+
+#include <sys/wait.h>
+#include <sys/ioctl.h>
+
+#include <dev/filemon/filemon.h>
+
+#include <stdio.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <stdlib.h>
+#include <err.h>
+
+/*
+ * This simple test of filemon expects a test script called
+ * "test_script.sh" in the cwd.
+ */
+
+int
+main(void) {
+ char log_name[] = "filemon_log.XXXXXX";
+ pid_t child;
+ int fm_fd, fm_log;
+
+ if ((fm_fd = open("/dev/filemon", O_RDWR)) == -1)
+ err(1, "open(\"/dev/filemon\", O_RDWR)");
+ if ((fm_log = mkstemp(log_name)) == -1)
+ err(1, "mkstemp(%s)", log_name);
+
+ if (ioctl(fm_fd, FILEMON_SET_FD, &fm_log) == -1)
+ err(1, "Cannot set filemon log file descriptor");
+
+ /* Set up these two fd's to close on exec. */
+ (void)fcntl(fm_fd, F_SETFD, FD_CLOEXEC);
+ (void)fcntl(fm_log, F_SETFD, FD_CLOEXEC);
+
+ switch (child = fork()) {
+ case 0:
+ child = getpid();
+ if (ioctl(fm_fd, FILEMON_SET_PID, &child) == -1)
+ err(1, "Cannot set filemon PID to %d", child);
+ system("./test_script.sh");
+ break;
+ case -1:
+ err(1, "Cannot fork");
+ default:
+ wait(&child);
+ close(fm_fd);
+// printf("Results in %s\n", log_name);
+ break;
+ }
+ return 0;
+}
diff --git a/tools/regression/filemon/test_script.sh b/tools/regression/filemon/test_script.sh
new file mode 100755
index 000000000000..df34ec4a3859
--- /dev/null
+++ b/tools/regression/filemon/test_script.sh
@@ -0,0 +1,43 @@
+#! /bin/sh
+#
+# Copyright (c) 2011, Juniper Networks, Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY JUNIPER NETWORKS AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL JUNIPER NETWORKS OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+
+trap 'rm -f $f1 $f2; exit 1' 1 2 3 13 15
+echo shazbot > /dev/null
+f1=`mktemp /tmp/filemon_test.XXXXXX`
+f2=`mktemp /tmp/ed-script.XXXXXX`
+> $f1
+echo "One line to rule them all" >> $f1
+wc -l $f1 > /dev/null
+# ed(1)'s /tmp/ed.* buffer file will be opened RW
+echo ',s/$/./g' > $f2
+echo 'wq' >>$f2
+ed -s $f1 < $f2
+#echo ",s/$/./\
+#w" | ed -s $f1
+#rm $f1 $f2
+uptime > /dev/null